<template>
  <div class="login">
    <el-form ref="loginRef" :model="loginForm" :rules="loginRules" class="login-form">
      <h3 class="title">面向科创园区的普惠算力公共服务平台</h3>
      <el-tabs v-model="activeName" class="demo-tabs" @tab-click="handleClick">
        <el-tab-pane label="手机号登录" :name="0" style="padding-top: 10px;">
          <el-form-item prop="phoneNumber" v-if="activeName === 0">
            <el-input
                v-model="loginForm.phoneNumber"
                type="text"
                size="large"
                auto-complete="off"
                placeholder="手机号">
              <template #prefix>
                <svg-icon icon-class="phone" class="el-input__icon input-icon"/>
              </template>
            </el-input>
          </el-form-item>
          <el-form-item prop="code" v-if="activeName === 0">
            <el-input
                v-model="loginForm.code"
                type="text"
                size="large"
                auto-complete="off"
                placeholder="验证码">
              <template #prefix>
                <svg-icon icon-class="code" class="el-input__icon input-icon"/>
              </template>
              <template #append>
                <el-button @click="startCountdown" :disabled="isCounting">
                  {{ isCounting ? `重新发送(${countdown})` : '发送验证码' }}
                </el-button>
              </template>
            </el-input>
          </el-form-item>
        </el-tab-pane>
        <el-tab-pane label="账号登录" :name="1" style="padding-top: 10px;">
          <el-form-item prop="mobile" v-if="activeName === 1">
            <el-input
                v-model="loginForm.mobile"
                type="text"
                size="large"
                auto-complete="off"
                placeholder="账号">
              <template #prefix>
                <svg-icon icon-class="user" class="el-input__icon input-icon"/>
              </template>
            </el-input>
          </el-form-item>
          <el-form-item prop="password" v-if="activeName === 1">
            <el-input
                v-model="loginForm.password"
                type="password"
                size="large"
                auto-complete="off"
                placeholder="密码"
                @keyup.enter="handleLogin">
              <template #prefix>
                <svg-icon icon-class="password" class="el-input__icon input-icon"/>
              </template>
            </el-input>
          </el-form-item>
        </el-tab-pane>
      </el-tabs>

      <div class="flex-align-center flex-space-between mb20" style="height: 32px;">
        <el-checkbox v-show="activeName === 1" v-model="loginForm.rememberMe">记住密码</el-checkbox>
        <div v-if="register">
          <router-link class="link-type" :to="'/register'">立即注册</router-link>
        </div>
      </div>

      <el-form-item style="width:100%;">
        <el-button
            :loading="loading"
            size="large"
            type="primary"
            style="width:100%;"
            @click.prevent="handleLogin">
          <span v-if="!loading">登 录</span>
          <span v-else>登 录 中...</span>
        </el-button>

      </el-form-item>
    </el-form>
    <!--  底部  -->
    <div class="el-login-footer">
      <!--      <span>Copyright © 2018-2024 ruoyi.vip All Rights Reserved.</span>-->
    </div>
  </div>
</template>

<script setup>
import Cookies from 'js-cookie'
import {encrypt, decrypt} from '@/utils/jsencrypt'
import useUserStore from '@/store/modules/user'
import {useRoute, useRouter} from 'vue-router'
import {getInfo, sendCode} from "@/api/login.js";
import {ElMessage} from "element-plus";

const userStore = useUserStore()
const route = useRoute()
const router = useRouter()
const {proxy} = getCurrentInstance()

const loginForm = ref({
  mobile: '',
  password: '',
  rememberMe: false,
  code: '',
  uuid: '',
  phoneNumber: ''
})

const loginRules = {
  mobile: [{required: true, trigger: 'blur', message: '请输入您的手机号'}],
  password: [{required: true, trigger: 'blur', message: '请输入您的密码'}],
  code: [{required: true, trigger: 'change', message: '请输入验证码'}],
  phoneNumber: [
    {required: true, trigger: 'blur', message: '请输入手机号码'},
    {validator: validatePhone},
  ]
}

const loginRef = ref(null)
const activeName = ref(0)
const loading = ref(false)
// 验证码开关
const captchaEnabled = ref(false)
// 注册开关
const register = ref(false)
const redirect = ref(undefined)
const countdown = ref(60); // 倒计时时间，初始为60秒
const isCounting = ref(false); // 是否正在倒计时的标志

// 开始倒计时的方法
const startCountdown = () => {
  getCode()
  loginRef.value.validateField('phoneNumber', valid => {
    if (valid) {
      if (isCounting.value) return; // 如果已经在倒计时，则不重复开始
      isCounting.value = true; // 设置正在倒计时的标志为true
      const timer = setInterval(() => {
        if (countdown.value > 0) {
          countdown.value--; // 倒计时减1
        } else {
          clearInterval(timer); // 倒计时结束，清除定时器
          isCounting.value = false; // 设置正在倒计时的标志为false
          countdown.value = 60; // 重置倒计时时间
        }
      }, 1000); // 每1000毫秒（1秒）执行一次
    }
  })
};

function getCode() {
  sendCode({mobile: loginForm.value.phoneNumber, scene: 1}).then(res => {
    if (res.data === true) {
      ElMessage({message: '短信已发送请注意查收', type: 'success'})
    }
  })
}

function validatePhone(rule, value, callback) {
  const reg = /^1[3456789]\d{9}$/
  if (!reg.test(value)) {
    callback(new Error('请输入正确的手机号'))
    return
  }
  callback()
}

watch(route, (newRoute) => {
  redirect.value = newRoute.query && newRoute.query.redirect
}, {immediate: true})

function handleClick() {
  proxy.$refs.loginRef.resetFields()
}

function handleLogin() {
  proxy.$refs.loginRef.validate(valid => {
    if (valid) {
      loading.value = true
      if (activeName.value === 1) {
        // 勾选了需要记住密码设置在 cookie 中设置记住用户名和密码
        if (loginForm.value.rememberMe) {
          Cookies.set('mobile', loginForm.value.mobile, {expires: 30})
          Cookies.set('password', encrypt(loginForm.value.password), {expires: 30})
          Cookies.set('rememberMe', loginForm.value.rememberMe, {expires: 30})
        } else {
          // 否则移除
          Cookies.remove('mobile')
          Cookies.remove('password')
          Cookies.remove('rememberMe')
        }
        // 调用action的登录方法
        userStore.login(loginForm.value).then(() => {
          const query = route.query
          const otherQueryParams = Object.keys(query).reduce((acc, cur) => {
            if (cur !== 'redirect') {
              acc[cur] = query[cur]
            }
            return acc
          }, {})
          useUserStore().getInfo().then(res => {
            localStorage.setItem('avatar', res.data.avatar);
          })
          router.push({path: redirect.value || '/', query: otherQueryParams})
        }).catch(() => {
          loading.value = false
        })
      } else {
        userStore.cellPhoneLogin({mobile: loginForm.value.phoneNumber, code: loginForm.value.code}).then(res => {
          const query = route.query
          const otherQueryParams = Object.keys(query).reduce((acc, cur) => {
            if (cur !== 'redirect') {
              acc[cur] = query[cur]
            }
            return acc
          }, {})
          useUserStore().getInfo().then(res => {
          })
          router.push({path: redirect.value || '/', query: otherQueryParams})
        }).catch(() => {
          loading.value = false
        })
      }
    }
  })
}


function getCookie() {
  const mobile = Cookies.get('mobile')
  const password = Cookies.get('password')
  const rememberMe = Cookies.get('rememberMe')
  loginForm.value = {
    mobile: mobile === undefined ? loginForm.value.mobile : mobile,
    password: password === undefined ? loginForm.value.password : decrypt(password),
    rememberMe: rememberMe === undefined ? false : Boolean(rememberMe)
  }
}

getCookie()
</script>

<style lang='scss' scoped>
.login {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
  background-image: url("../assets/images/login-background.png");
  background-size: cover;
}

.title {
  margin: 0px auto 30px auto;
  text-align: center;
  color: #2E77E3;
  font-size: 30px;
  font-family: YouSheBiaoTiHei, system-ui;
}

.login-form {
  border-radius: 2px;
  background: #ffffff;
  width: 400px;
  margin-left: 18%;
  padding: 35px 35px 15px 35px;
  box-shadow: 0 0 10px 0 rgba(209, 224, 251, 0.79);

  .el-input {
    height: 40px;

    input {
      height: 40px;
    }
  }

  .input-icon {
    height: 39px;
    width: 14px;
    margin-left: 0px;
  }
}

.login-tip {
  font-size: 13px;
  text-align: center;
  color: #bfbfbf;
}

.login-code {
  width: 33%;
  height: 40px;
  float: right;

  img {
    cursor: pointer;
    vertical-align: middle;
  }
}

.el-login-footer {
  height: 40px;
  line-height: 40px;
  position: fixed;
  bottom: 0;
  width: 100%;
  text-align: center;
  color: #fff;
  font-family: Arial;
  font-size: 12px;
  letter-spacing: 1px;
}

.login-code-img {
  height: 40px;
  padding-left: 12px;
}

.link-type {
  font-size: 14px;
  font-weight: 500;
  color: var(--el-color-primary);
}
</style>
